# include "all.h"



unsigned long int ay_sys_getword(unsigned char *p)
{
    return *p | ((*(p + 1)) << 8);
}

void ay_sys_writeword(unsigned char *p, unsigned int val)
{
    *p = (unsigned char)(val & 0xff);
    *(p + 1) = (unsigned char)((val >> 8) & 0xff);
}

///unsigned char c1, c2, c3;

char copy[16];

void ay_writeay(unsigned char reg, unsigned char val)
{
     if ((reg==0xff) && (val==0xff))
      {
             output(0xFFFD, 8); output(0xBFFD, copy[8]);  
             output(0xFFFD, 9); output(0xBFFD, copy[9]);  
             output(0xFFFD, 10); output(0xBFFD, copy[10]);  
             
             return;
      }

      copy[reg] = val;

/*
      if (reg==AY_CHNL_A_VOL)        c1 = val;
      else
      if (reg==AY_CHNL_B_VOL)        c2 = val;
      else
      if (reg==AY_CHNL_C_VOL)        c3 = val;
  */
           
     output(0xFFFD, reg);
     output(0xBFFD, val);
}

char ay_readay(unsigned char reg)
{
      return(copy[reg]);


      //output(0xFFFD, reg);
      //return(input(0xBFFD));
      
}



typedef struct 
{
    unsigned char PT2_Delay;
    unsigned char PT2_NumberOfPositions;
    unsigned char PT2_LoopPosition;
    unsigned char PT2_SamplesPointers0[64];
    unsigned char PT2_OrnamentsPointers0[32];
    unsigned char PT2_PatternsPointer0, PT2_PatternsPointer1;
    char PT2_MusicName[30];
    unsigned char PT2_PositionList[65535 - 131];
} PT2_File;

typedef struct 
{
    unsigned char DelayCounter, Delay, CurrentPosition;
} PT2_Parameters;


typedef struct 
{
    unsigned int Address_In_Pattern, OrnamentPointer, SamplePointer, Ton;
    unsigned char Loop_Ornament_Position, Ornament_Length, Position_In_Ornament, Loop_Sample_Position, Sample_Length, Position_In_Sample, Volume, Number_Of_Notes_To_Skip, Note, Slide_To_Note,Amplitude;
    signed char Current_Ton_Sliding, Ton_Delta;
    long int GlissType;
    bool Envelope_Enabled, Enabled;
    signed char Glissade, Addition_To_Noise, Note_Skip_Counter;
} PT2_Channel_Parameters;

typedef struct 
{
    PT2_Parameters PT2;
    PT2_Channel_Parameters PT2_A, PT2_B, PT2_C;
} PT2_SongInfo;


#define PT2_A ((PT2_SongInfo *)info->data)->PT2_A
#define PT2_B ((PT2_SongInfo *)info->data)->PT2_B
#define PT2_C ((PT2_SongInfo *)info->data)->PT2_C
#define PT2 ((PT2_SongInfo *)info->data)->PT2

#define PT2_SamplesPointers(x) (header->PT2_SamplesPointers0 [(x) * 2] | (header->PT2_SamplesPointers0 [(x) * 2 + 1] << 8))
#define PT2_OrnamentsPointers(x) (header->PT2_OrnamentsPointers0 [(x) * 2] | (header->PT2_OrnamentsPointers0 [(x) * 2 + 1] << 8))

//#define PT2_OrnamentsPointers(x) (header->PT2_OrnamentsPointers0 [(x) * 2] + (header->PT2_OrnamentsPointers0 [(x) * 2 + 1] * 256))

#define PT2_PositionList(x) (header->PT2_PositionList [(x)])
#define PT2_PatternsPointer (header->PT2_PatternsPointer0 | (header->PT2_PatternsPointer1 << 8))
#define PT2_Delay (header->PT2_Delay)
#define PT2_NumberOfPositions (header->PT2_NumberOfPositions)
#define PT2_LoopPosition (header->PT2_LoopPosition)

PT2_SongInfo PT2_SongInfoV;

void PT2_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    PT2_File * header = (PT2_File *)module;
    
    info->data = (void *)& PT2_SongInfoV;
    
	
    memset(&PT2_A, 0, sizeof(PT2_Channel_Parameters));
    memset(&PT2_B, 0, sizeof(PT2_Channel_Parameters));
    memset(&PT2_C, 0, sizeof(PT2_Channel_Parameters));
    
    PT2.DelayCounter = 1;
    PT2.Delay = PT2_Delay;
    PT2.CurrentPosition = 0;

    PT2_A.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer+ PT2_PositionList(0) * 6]);
    PT2_B.Address_In_Pattern = ay_sys_getword(&module [PT2_PatternsPointer + PT2_PositionList(0) * 6 + 2]);
    PT2_C.Address_In_Pattern = ay_sys_getword(&module [PT2_PatternsPointer + PT2_PositionList(0) * 6 + 4]);

    PT2_A.OrnamentPointer = PT2_OrnamentsPointers(0);
    PT2_A.Ornament_Length = module[PT2_A.OrnamentPointer];
    PT2_A.OrnamentPointer++;
    PT2_A.Loop_Ornament_Position = module[PT2_A.OrnamentPointer];
    PT2_A.OrnamentPointer++;
    PT2_A.Envelope_Enabled = false;
    PT2_A.Position_In_Sample = 0;
    PT2_A.Position_In_Ornament = 0;
    PT2_A.Addition_To_Noise = 0;
    PT2_A.Glissade = 0;
    PT2_A.Current_Ton_Sliding=0;
    PT2_A.GlissType = 0;
    PT2_A.Enabled = false;
    PT2_A.Number_Of_Notes_To_Skip = 0;
    PT2_A.Note_Skip_Counter = 0;
    PT2_A.Volume = 15;
    PT2_A.Ton = 0;

    PT2_B.OrnamentPointer = PT2_A.OrnamentPointer;
    PT2_B.Loop_Ornament_Position = PT2_A.Loop_Ornament_Position;
    PT2_B.Ornament_Length = PT2_A.Ornament_Length;
    PT2_B.Envelope_Enabled = false;
    PT2_B.Position_In_Sample = 0;
    PT2_B.Position_In_Ornament = 0;
    PT2_B.Addition_To_Noise = 0;
    PT2_B.Glissade = 0;
    PT2_B.Current_Ton_Sliding = 0;
    PT2_B.GlissType = 0;
    PT2_B.Enabled = false;
    PT2_B.Number_Of_Notes_To_Skip = 0;
    PT2_B.Note_Skip_Counter = 0;
    PT2_B.Volume = 15;
    PT2_B.Ton = 0;

    PT2_C.OrnamentPointer = PT2_A.OrnamentPointer;
    PT2_C.Loop_Ornament_Position = PT2_A.Loop_Ornament_Position;
    PT2_C.Ornament_Length = PT2_A.Ornament_Length;
    PT2_C.Envelope_Enabled = false;
    PT2_C.Position_In_Sample = 0;
    PT2_C.Position_In_Ornament = 0;
    PT2_C.Addition_To_Noise = 0;
    PT2_C.Glissade = 0;
    PT2_C.Current_Ton_Sliding = 0;
    PT2_C.GlissType = 0;
    PT2_C.Enabled = false;
    PT2_C.Number_Of_Notes_To_Skip = 0;
    PT2_C.Note_Skip_Counter = 0;
    PT2_C.Volume = 15;
    PT2_C.Ton = 0;
    
//    ay_resetay(&info, 0);
}

unsigned char PT2_Detect0(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    int j, j1, j2;
    long int F_Length;
    

    
    PT2_File * header = (PT2_File *)module;
    
        
    //return true;
    
    
    if(length < 132)
        return false;
        
     //s->err  = 10;
        
    if(PT2_PatternsPointer> length)
        return false;
        
    // s->err  = 20;
    
    if(module[PT2_PatternsPointer-1] != 255)
        return false;
    
    //s->err  = 30;    
        
    if(PT2_SamplesPointers(0) != 0)
        return false;
        
   // s->err  = 50;    
    
    j = 0;
    memcpy((char *)&j, (char *)&module[PT2_OrnamentsPointers(0)], 3);
    if(j != 1)
    {
       // memcpy(&s->counter, &module[0x0779], 2); 
        return false;
    }
        
    //s->err = 90;

    j = ay_sys_getword(&module[PT2_PatternsPointer]);
    if(j > length)
        return false;
    if(j - (long int)(PT2_PatternsPointer) <= 0)
        return false;
    if(((j - (long int)(PT2_PatternsPointer)) % 6) != 2)
        return false;

   // s->err  = 190;


    j1 = 0;
    j2 = 0;
    while(((j2 < 256) && (j2 <= length - 131)) && (header->PT2_PositionList[j2] < 128))
    {
        if((unsigned long)(j1) < header->PT2_PositionList[j2])
            j1 = header->PT2_PositionList[j2];
        j2++;
    }
    if(((j - (long int)(PT2_PatternsPointer)) / 6) != j1 + 1)
        return false;

   // s->err  = 290;


    j = 15;
    while((j > 0) && (PT2_OrnamentsPointers(j) == 0))
        j--;
    F_Length = PT2_OrnamentsPointers(j) + module[PT2_OrnamentsPointers(j)] + 2;
    if(F_Length > (length+256))
    {
       //  s->err  =F_Length;
        return false;
        }

    PT2_NumberOfPositions = j2;
    return true;
}

bool PT2_Detect1(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    int j, j1, j2, j3;
    long int F_Length;
    
    
   // return false;
    
    PT2_File *header = (PT2_File *)module;
    
    if(length < 132)
        return false;
    if(PT2_PatternsPointer > length)
        return false;
    if(module[PT2_PatternsPointer-1] != 255)
        return false;
    if(PT2_SamplesPointers(0) != 0)
        return false;

     

    j3 = PT2_SamplesPointers(0);
    if(PT2_OrnamentsPointers(0) - j3 - 2 > length)
        return false;
    
    // s->err = 400;
        
    if(PT2_OrnamentsPointers(0)- j3 < 0)
        return false;

    // s->err = 500;

    j = 0;
    memcpy((char *)&j, (char *)&module[PT2_OrnamentsPointers(0)], 3);
    if(j != 1)
        return false;
  
    //s->err = 1000;

    j = ay_sys_getword(&module[PT2_PatternsPointer]);
    j -= j3;
    if(j > length)
        return false;
    
    //s->err = 2000; 
       
    if(j - (long int)(PT2_PatternsPointer) <= 0)
        return false;
        
    //s->err = 3000;
        
    if(((j - (long int)(PT2_PatternsPointer)) % 6) != 2)
        return false;

   //s->err = 4000;

    j1 = 0;
    j2 = 0;
    while(((j2 < 256) && (j2 <= length - 131)) && (header->PT2_PositionList[j2] < 128))
    {
        if((unsigned long)(j1) < header->PT2_PositionList[j2])
            j1 = header->PT2_PositionList[j2];
        j2++;
    }
    if(((j - (long int)(PT2_PatternsPointer)) / 6) != j1 + 1)
        return false;

    j = 15;
    while((j > 0) && (PT2_OrnamentsPointers(j) == j3))
        j--;
    F_Length = PT2_OrnamentsPointers(j) - j3 + module[PT2_OrnamentsPointers(j) - j3] + 2;
    if(F_Length > length + 1)
        return false;

    PT2_NumberOfPositions = j2;
    for(j = 0; j < 32; j++)
    {
        ay_sys_writeword(&header->PT2_SamplesPointers0[j * 2], PT2_SamplesPointers(j) - j3);
    }
    for(j = 0; j < 16; j++)
    {
        ay_sys_writeword(&header->PT2_OrnamentsPointers0[j * 2], PT2_OrnamentsPointers(j) - j3);
    }
    for(j2 = 0; j2 < j1 * 3 + 1; j2++)
    {
        j = ay_sys_getword(&module[PT2_PatternsPointer+j2 * 2]);
        j -= j3;
        ay_sys_writeword(&module[PT2_PatternsPointer+j2 * 2], j);
    }
    return true;
}

bool PT2_Detect(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    if(!PT2_Detect0(module, length, s))
        if(!PT2_Detect1(module, length, s))
            return false;
            
    strcpy(s->player, "Pro Tracker v2");
            
    return true;
}

const unsigned int PT2_Table[96] =
{ 0xef8, 0xe10, 0xd60, 0xc80, 0xbd8, 0xb28, 0xa88, 0x9f0, 0x960, 0x8e0, 0x858, 0x7e0, 0x77c, 0x708, 0x6b0, 0x640, 0x5ec, 0x594, 0x544, 0x4f8, 0x4b0, 0x470, 0x42c, 0x3fd, 0x3be, 0x384, 0x358, 
 0x320, 0x2f6, 0x2ca, 0x2a2, 0x27c, 0x258, 0x238, 0x216, 0x1f8, 0x1df, 0x1c2, 0x1ac, 0x190, 0x17b, 0x165, 0x151, 0x13e, 0x12c, 0x11c, 0x10a, 0xfc, 0xef, 0xe1, 0xd6, 0xc8, 0xbd, 0xb2, 0xa8, 0x9f,
 0x96, 0x8e, 0x85, 0x7e, 0x77, 0x70, 0x6b, 0x64, 0x5e, 0x59, 0x54, 0x4f, 0x4b, 0x47, 0x42, 0x3f, 0x3b, 0x38, 0x35, 0x32, 0x2f, 0x2c, 0x2a, 0x27, 0x25, 0x23, 0x21, 0x1f, 0x1d, 0x1c, 0x1a, 0x19,
 0x17, 0x16, 0x15, 0x13, 0x12, 0x11, 0x10, 0xf };

void PT2_PatternInterpreter(AYSongInfo * info, PT2_Channel_Parameters * chan)
{
    unsigned char * module = info->module;
    PT2_File * header = (PT2_File *)module;
    bool quit, gliss;
	unsigned char val;
	
    quit = false;
    gliss = false;
    
	do
    {
        val = module[chan->Address_In_Pattern];
        if(val >= 0xe1)
        {
            chan->SamplePointer = PT2_SamplesPointers(val - 0xe0);
            chan->Sample_Length = module[chan->SamplePointer];
            chan->SamplePointer++;
            chan->Loop_Sample_Position = module[chan->SamplePointer];
            chan->SamplePointer++;
        }
        else if(val == 0xe0)
        {
            chan->Position_In_Sample = 0;
            chan->Position_In_Ornament = 0;
            chan->Current_Ton_Sliding = 0;
            chan->GlissType = 0;
            chan->Enabled = false;
            quit = true;
        }
        else if(val >= 0x80 && val <= 0xdf)
        {
            chan->Position_In_Sample = 0;
            chan->Position_In_Ornament = 0;
            chan->Current_Ton_Sliding = 0;
            if(gliss)
            {
                chan->Slide_To_Note = val - 0x80;
                if(chan->GlissType == 1)
                    chan->Note = chan->Slide_To_Note;
            }
            else
            {
                chan->Note = val - 0x80;
                chan->GlissType = 0;
            }
            chan->Enabled = true;
            quit = true;
        }
        else if(val == 0x7f)
            chan->Envelope_Enabled = false;
        else if(val >= 0x71 && val <= 0x7e)
        {
            chan->Envelope_Enabled = true;
            ay_writeay(AY_ENV_SHAPE, val - 0x70);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern]);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_COARSE, module[chan->Address_In_Pattern]);
        }
        else if(val == 0x70)
            quit = true;
        else if(val >= 0x60 && val <= 0x6f)
        {
            chan->OrnamentPointer = PT2_OrnamentsPointers(val - 0x60);
            chan->Ornament_Length = module[chan->OrnamentPointer];
            chan->OrnamentPointer++;
            chan->Loop_Ornament_Position = module[chan->OrnamentPointer];
            chan->OrnamentPointer++;
            chan->Position_In_Ornament = 0;
        }
        else if(val >= 0x20 && val <= 0x5f)
		            chan->Number_Of_Notes_To_Skip = val - 0x20;
        else if(val >= 0x10 && val <= 0x1f)
            chan->Volume = val - 0x10;
        else if(val == 0xf)
        {
            chan->Address_In_Pattern++;
            PT2.Delay = module[chan->Address_In_Pattern];
        }
        else if(val == 0xe)
        {
            chan->Address_In_Pattern++;
            chan->Glissade = module[chan->Address_In_Pattern];
            chan->GlissType = 1;
            gliss = true;
        }
        else if(val == 0xd)
        {
            chan->Address_In_Pattern++;
            chan->Glissade = abs((signed char)(module[chan->Address_In_Pattern]));
            chan->Address_In_Pattern += 2; //Not use precalculated Ton_Delta
            //to avoide error with first note of pattern
            chan->GlissType = 2;
            gliss = true;
        }
        else if(val == 0xc)
            chan->GlissType = 0;
        else
        {
            chan->Address_In_Pattern++;
            chan->Addition_To_Noise = module[chan->Address_In_Pattern];
        }
        chan->Address_In_Pattern++;
    }
    while(!quit);
    if(gliss && (chan->GlissType == 2))
    {
        chan->Ton_Delta = abs(PT2_Table[chan->Slide_To_Note] - PT2_Table[chan->Note]);
        if(chan->Slide_To_Note > chan->Note)
            chan->Glissade = -chan->Glissade;
    }
    chan->Note_Skip_Counter = chan->Number_Of_Notes_To_Skip;
}

void PT2_GetRegisters(AYSongInfo * info, PT2_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char j, b0, b1;
    unsigned char *module = info->module;
    PT2_File *header = (PT2_File *)module;
	
    if(chan->Enabled)
    {
        b0 = module[chan->SamplePointer + chan->Position_In_Sample * 3];
        b1 = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 1];
        chan->Ton = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 2] + (unsigned short)((b1 & 15) << 8);
        if((b0 & 4) == 0)
            chan->Ton = -chan->Ton;
        j = chan->Note + module[chan->OrnamentPointer + chan->Position_In_Ornament];
        if(j > 95)
            j = 95;
        chan->Ton = (chan->Ton + chan->Current_Ton_Sliding + PT2_Table[j]) & 0xfff;
        if(chan->GlissType == 2)
        {
            chan->Ton_Delta = chan->Ton_Delta - abs(chan->Glissade);
            if(chan->Ton_Delta < 0)
            {
                chan->Note = chan->Slide_To_Note;
                chan->GlissType = 0;
                chan->Current_Ton_Sliding = 0;
            }
        }
        if(chan->GlissType != 0)
            chan->Current_Ton_Sliding += chan->Glissade;
        chan->Amplitude = (chan->Volume * 17 + (unsigned char)(chan->Volume > 7)) * (b1 >> 4) / 256;
        if(chan->Envelope_Enabled)
            chan->Amplitude = chan->Amplitude | 16;
        if((module[chan->SamplePointer + chan->Position_In_Sample * 3] & 1) != 0)
            *TempMixer = *TempMixer | 64;
        else
            ay_writeay(AY_NOISE_PERIOD, ((b0 >> 3) + chan->Addition_To_Noise) & 31);
        if((b0 & 2) != 0)
            *TempMixer = *TempMixer | 8;
        chan->Position_In_Sample++;
        if(chan->Position_In_Sample == chan->Sample_Length)
            chan->Position_In_Sample = chan->Loop_Sample_Position;
        chan->Position_In_Ornament++;
        if(chan->Position_In_Ornament == chan->Ornament_Length)
            chan->Position_In_Ornament = chan->Loop_Ornament_Position;
    }
    else
        chan->Amplitude = 0;
		
    *TempMixer = *TempMixer >> 1;
}

void PT2_Play(AYSongInfo * info)
{
    unsigned char TempMixer;
    unsigned char * module = info->module;
    PT2_File * header = (PT2_File *)module;
    PT2.DelayCounter--;
    if(PT2.DelayCounter == 0)
    {
        PT2_A.Note_Skip_Counter--;
        if(PT2_A.Note_Skip_Counter < 0)
        {
            if(module[PT2_A.Address_In_Pattern] == 0)
            {
                PT2.CurrentPosition++;
                if(PT2.CurrentPosition == PT2_NumberOfPositions)
                    PT2.CurrentPosition = PT2_LoopPosition;
                PT2_A.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer+ PT2_PositionList(PT2.CurrentPosition) * 6]);
                PT2_B.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer + PT2_PositionList(PT2.CurrentPosition) * 6 + 2]);
                PT2_C.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer + PT2_PositionList(PT2.CurrentPosition) * 6 + 4]);
            }
            PT2_PatternInterpreter(info, &PT2_A);
        }
        PT2_B.Note_Skip_Counter--;
        if(PT2_B.Note_Skip_Counter < 0)
        PT2_PatternInterpreter(info, &PT2_B);
        PT2_C.Note_Skip_Counter--;
        if(PT2_C.Note_Skip_Counter < 0)
        PT2_PatternInterpreter(info, &PT2_C);
        PT2.DelayCounter = PT2.Delay;
    }

    TempMixer = 0;
    PT2_GetRegisters(info, &PT2_A, &TempMixer);
    PT2_GetRegisters(info, &PT2_B, &TempMixer);
    PT2_GetRegisters(info, &PT2_C, &TempMixer);

	///*
    ay_writeay(AY_MIXER, TempMixer);

    ay_writeay(AY_CHNL_A_FINE, PT2_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (PT2_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, PT2_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (PT2_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, PT2_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (PT2_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, PT2_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, PT2_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, PT2_C.Amplitude);
	//*/
}

void PT2_GetInfo(AYSongInfo * info)
{
    unsigned char *module = info->module;
    int a1, a2, a3, a11, a22, a33;
    unsigned long int j1, j2, j3;
    long i, tm = 0;
    unsigned char b;
    unsigned char ptDelay = module[0];
    unsigned char ptNumPos = module[1];
    unsigned int ptLoopPos = module[2];
    unsigned int ptPatPt = ay_sys_getword(&module[99]);
    const unsigned char *ptPosList = (unsigned char *)&module[131];

	
    b = ptDelay;
    a1 = a2 = a3 = a11 = a22 = a33 = 0;
    for(i = 0; i < ptNumPos; i++)
    {
        if(i == ptLoopPos)
        {
           // info->Loop = tm;
        }
        j1 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6]);
        j2 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6 + 2]);
        j3 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6 + 4]);
        do
        {
            a1--;
            if(a1 < 0)
            {
                if(module[j1] == 0)
                    break;
                do
                {
                    unsigned char val = (unsigned char)module[j1];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a1 = a11;
                        j1++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j1 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a11 = module[j1] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j1++;
                        b = module[j1];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j1++;
                    }
                    else if(val == 0xd)
                    {
                        j1 += 3;
                    }
                    j1++;
                }
                while(true);
            }

            a2--;
            if(a2 < 0)
            {
                do
                {
                    unsigned char val = (unsigned char)module[j2];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a2 = a22;
                        j2++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j2 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a22 = module[j2] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j2++;
                        b = module[j2];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j2++;
                    }
                    else if(val == 0xd)
                    {
                        j2 += 3;
                    }
                    j2++;
                }
                while(true);
            }
            a3--;
            if(a3 < 0)
            {
                do
                {
                    unsigned char val = (unsigned char)module[j3];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a3 = a33;
                        j3++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j3 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a33 = module[j3] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j3++;
                        b = module[j3];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j3++;
                    }
                    else if(val == 0xd)
                    {
                        j3 += 3;
                    }
                    j3++;
                }
                while(true);
            }
            tm += b;
        }
        while(true);
    }
	
    info->len = tm;
    strncpy(info->Name, &module[101], 30);
    info->Autor[0]=0;
}






//======================== PT1 =============================

typedef struct
{
    unsigned char PT1_Delay;
    unsigned char PT1_NumberOfPositions;
    unsigned char PT1_LoopPosition;
    unsigned char PT1_SamplesPointers0[32]; //word
    unsigned char PT1_OrnamentsPointers0[32]; //word
    unsigned char PT1_PatternsPointer0, PT1_PatternsPointer1;
    signed char PT1_MusicName[30];
    unsigned char PT1_PositionList[65536 - 99];
} PT1_File;

#define PT1_SamplesPointers(x) (header->PT1_SamplesPointers0 [(x) * 2] | (header->PT1_SamplesPointers0 [(x) * 2 + 1] << 8))
#define PT1_OrnamentsPointers(x) (header->PT1_OrnamentsPointers0 [(x) * 2] | (header->PT1_OrnamentsPointers0 [(x) * 2 + 1] << 8))
#define PT1_PatternsPointer (header->PT1_PatternsPointer0 | (header->PT1_PatternsPointer1 << 8))

typedef struct 
{
    unsigned int Address_In_Pattern, OrnamentPointer, SamplePointer, Ton;
    unsigned char Number_Of_Notes_To_Skip, Volume, Loop_Sample_Position, Position_In_Sample, Sample_Length, Amplitude, Note;
    signed char Note_Skip_Counter;
    bool Envelope_Enabled, Enabled;
} PT1_Channel_Parameters;

typedef struct 
{
    unsigned char Delay, DelayCounter, CurrentPosition;
} PT1_Parameters;

typedef struct 
{
    PT1_Parameters PT1;
    PT1_Channel_Parameters PT1_A, PT1_B, PT1_C;
} PT1_SongInfo;

PT1_SongInfo PT1_SongInfoV;

#define PT1_A ((PT1_SongInfo *)info->data)->PT1_A
#define PT1_B ((PT1_SongInfo *)info->data)->PT1_B
#define PT1_C ((PT1_SongInfo *)info->data)->PT1_C
#define PT1 ((PT1_SongInfo *)info->data)->PT1

void PT1_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    
    PT1_File *header = (PT1_File *)module;
    
    info->data = (void *)& PT1_SongInfoV;
    
    
    memset(&PT1_A, 0, sizeof(PT1_Channel_Parameters));
    memset(&PT1_B, 0, sizeof(PT1_Channel_Parameters));
    memset(&PT1_C, 0, sizeof(PT1_Channel_Parameters));

    PT1.DelayCounter = 1;
    PT1.Delay = header->PT1_Delay;
    PT1.CurrentPosition = 0;
    PT1_A.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6]);
    PT1_B.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6 + 2]);
    PT1_C.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6 + 4]);

    PT1_A.OrnamentPointer = PT1_OrnamentsPointers(0);
    PT1_A.Envelope_Enabled = false;
    PT1_A.Position_In_Sample = 0;
    PT1_A.Enabled = false;
    PT1_A.Number_Of_Notes_To_Skip = 0;
    PT1_A.Note_Skip_Counter = 0;
    PT1_A.Volume = 15;
    PT1_A.Ton = 0;

    PT1_B.OrnamentPointer = PT1_A.OrnamentPointer;
    PT1_B.Envelope_Enabled = false;
    PT1_B.Position_In_Sample = 0;
    PT1_B.Enabled = false;
    PT1_B.Number_Of_Notes_To_Skip = 0;
    PT1_B.Note_Skip_Counter = 0;
    PT1_B.Volume = 15;
    PT1_B.Ton = 0;

    PT1_C.OrnamentPointer = PT1_A.OrnamentPointer;
    PT1_C.Envelope_Enabled = false;
    PT1_C.Position_In_Sample = 0;
    PT1_C.Enabled = false;
    PT1_C.Number_Of_Notes_To_Skip = 0;
    PT1_C.Note_Skip_Counter = 0;
    PT1_C.Volume = 15;
    PT1_C.Ton = 0;

//    ay_resetay(&info, 0);
}

void PT1_PatternInterpreter(AYSongInfo * info, PT1_Channel_Parameters * chan)
{
    unsigned char *module = info->module;
    PT1_File *header = (PT1_File *)module;
    bool quit = false;
    do
    {
        unsigned char val = module[chan->Address_In_Pattern];
        if(val <= 0x5f)
        {
            chan->Note = val;
            chan->Enabled = true;
            chan->Position_In_Sample = 0;
            quit = true;
        }
        else if(val >= 0x60 && val <= 0x6f)
        {
            chan->SamplePointer = PT1_SamplesPointers(val - 0x60);
            chan->Sample_Length = module[chan->SamplePointer];
            chan->SamplePointer++;
            chan->Loop_Sample_Position = module[chan->SamplePointer];
            chan->SamplePointer++;
        }
        else if(val >= 0x70 && val <= 0x7f)
            chan->OrnamentPointer = PT1_OrnamentsPointers(val - 0x70);
        else if(val == 0x80)
        {
            chan->Enabled = false;
            quit = true;
        }
        else if(val == 0x81)
            chan->Envelope_Enabled = false;
        else if(val >= 0x82 && val <= 0x8f)
        {
            chan->Envelope_Enabled = true;
            ay_writeay(AY_ENV_SHAPE, val - 0x81);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern]);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_COARSE, module[chan->Address_In_Pattern]);
        }
        else if(val == 0x90)
            quit = true;
        else if(val >= 0x91 && val <= 0xa0)
            PT1.Delay = val - 0x91;
        else if(val >= 0xa1 && val <= 0xb0)
            chan->Volume = val - 0xa1;
        else
            chan->Number_Of_Notes_To_Skip = val - 0xb1;
        chan->Address_In_Pattern++;
    }
    while(!quit);
    chan->Note_Skip_Counter = chan->Number_Of_Notes_To_Skip;
}

void PT1_GetRegisters(AYSongInfo * info, PT1_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char *module = info->module;
    unsigned char j, b;
    if(chan->Enabled)
    {
        j = chan->Note + module[chan->OrnamentPointer + chan->Position_In_Sample];
        if(j > 95)
            j = 95;
        b = module[chan->SamplePointer + chan->Position_In_Sample * 3];
        chan->Ton = ((((unsigned short)(b)) << 4) & 0xf00) + module[chan->SamplePointer + chan->Position_In_Sample * 3 + 2];
        chan->Amplitude = (chan->Volume * 17 + (chan->Volume > 7 ? 1 : 0)) * (b & 15) / 256;
        b = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 1];
        if((b & 32) == 0)
            chan->Ton = -chan->Ton;
        chan->Ton = (chan->Ton + PT2_Table[j] + (j == 46 ? 1 : 0)) & 0xfff;
        if(chan->Envelope_Enabled)
            chan->Amplitude |= 16;
        if((signed char)b < 0)
            *TempMixer = *TempMixer | 64;
        else
            ay_writeay(AY_NOISE_PERIOD, b & 31);
        if((b & 64) != 0)
            *TempMixer = *TempMixer | 8;
        chan->Position_In_Sample++;
        if(chan->Position_In_Sample == chan->Sample_Length)
            chan->Position_In_Sample = chan->Loop_Sample_Position;
    }
    else
        chan->Amplitude = 0;
    *TempMixer = *TempMixer >> 1;

}

void PT1_Play(AYSongInfo * info)
{
    unsigned char *module = info->module;
    PT1_File *header = (PT1_File *)module;
    unsigned char TempMixer;
    PT1.DelayCounter--;
    if(PT1.DelayCounter == 0)
    {
        PT1_A.Note_Skip_Counter--;
        if(PT1_A.Note_Skip_Counter < 0)
        {
            if(module[PT1_A.Address_In_Pattern] == 255)
            {
                PT1.CurrentPosition++;
                if(PT1.CurrentPosition == header->PT1_NumberOfPositions)
                    PT1.CurrentPosition = header->PT1_LoopPosition;
                PT1_A.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6]);
                PT1_B.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6 + 2]);
                PT1_C.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6 + 4]);
            }
            PT1_PatternInterpreter(info, &PT1_A);
        }
        PT1_B.Note_Skip_Counter--;
        if(PT1_B.Note_Skip_Counter < 0)
            PT1_PatternInterpreter(info, &PT1_B);
        PT1_C.Note_Skip_Counter--;
        if(PT1_C.Note_Skip_Counter < 0)
            PT1_PatternInterpreter(info, &PT1_C);
        PT1.DelayCounter = PT1.Delay;
    }
    TempMixer = 0;
    PT1_GetRegisters(info, &PT1_A, &TempMixer);
    PT1_GetRegisters(info, &PT1_B, &TempMixer);
    PT1_GetRegisters(info, &PT1_C, &TempMixer);

    ay_writeay(AY_MIXER, TempMixer);

    ay_writeay(AY_CHNL_A_FINE, PT1_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (PT1_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, PT1_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (PT1_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, PT1_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (PT1_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, PT1_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, PT1_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, PT1_C.Amplitude);
}

void PT1_GetInfo(AYSongInfo * info)
{
    unsigned char * module = info->module;
    PT1_File *header = (PT1_File *)module;
    short a1, a2, a3, a11, a22, a33;
    unsigned long j1, j2, j3;
    long i, tm = 0;
    unsigned char b;
    unsigned char *ptr;
    
    
    b = header->PT1_Delay;
    a1 = a2 = a3 = a11 = a22 = a33 = 0;
    for(i = 0; i < header->PT1_NumberOfPositions; i++)
    {
        j1 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6]);
        j2 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6 + 2]);
        j3 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6 + 4]);
        while(true)
        {
            a1--;
            if(a1 < 0)
            {

                if(module[j1] == 255)
                    break;
                while(true)
                {
                    unsigned char val = module[j1];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a1 = a11;
                        j1++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j1 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a11 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j1++;
                }
            }
            a2--;
            if(a2 < 0)
            {

                while(true)
                {
                    unsigned char val = module[j2];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a2 = a22;
                        j2++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j2 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a22 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j2++;
                }
            }
            a3--;
            if(a3 < 0)
            {

                while(true)
                {
                    unsigned char val = module[j3];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a3 = a33;
                        j3++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j3 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a33 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j3++;
                }
            }
            tm += b;
        }
    }
    info->len = tm;
    ptr = module + 69;
    strncpy(info->Name, ptr, 30);
    info->Autor[0]=0;
}



bool PT1_Detect(unsigned char * module, unsigned int length, AYSongInfo * s)
{
    long j, j1, j2;
    long F_Length;
    
    PT1_File *header = (PT1_File *)module;
    if(length < 0x66)
        return false;
    if(PT1_PatternsPointer >= length)
        return false;

    j = 0;
    j1 = 65535;
    for(j2 = 0; j2 <= 15; j2++)
    {
        if(j < PT1_SamplesPointers(j2))
            j = PT1_SamplesPointers(j2);
        if((PT1_OrnamentsPointers(j2) != 0) && (j1 > PT1_OrnamentsPointers(j2)))
            j1 = PT1_OrnamentsPointers(j2);
    }

    if(j1 < 0x67)
        return false;
    if(j < 0x67)
        return false;
    if(j > 65534)
        return false;
    if(j > length)
        return false;
    if((j + module[j] * 3 + 2) != j1)
        return false;

    j = 0;
    for(j2 = 0; j2 <= 15; j2++)
        if(j < PT1_OrnamentsPointers(j2))
            j = PT1_OrnamentsPointers(j2);
    if(j < 0x67)
        return false;
    F_Length = j + 64;
    if(F_Length > 65536)
        return false;
    if(F_Length > length + 1)
        return false;

    j = 0x63;
    while((j <= PT1_PatternsPointer) && (module[j] != 255))
        j++;
    if(j + 1 != PT1_PatternsPointer)
        return false;

    header->PT1_NumberOfPositions = j - 0x63;
    
    strcpy(s->player, "Pro Tracker v1");
    
    return true;
}














////// LIB  //////



int abs(int value) 
{
  if (value < 0) 
  {
    return -value;
  }
  else 
  {
    return value;  
  }
}


void attr_new(char x, char y, char f, char t, char bright, char flash)
{
  int addr;
  unsigned char value=0;
  
  
  value+=f;
  value = value<<3;
  value+=t;
  
   if (bright)
    value |= 0x40;
  
  if (flash)
    value |= 0x80;
  
  addr = D_49152+6144+y*32+x;
  
  memset((void *)addr, value, 1);

}

void attr_old (unsigned int from, unsigned int len, char attr)
{
  unsigned int f;
  
  f=from+D_49152+6144;

  memset((void *)f, attr, len);
}

void ClearScreen(char * arg)
{	
     memset((void *)D_49152, 0, 6144);	
    
    gotoxy(0, 0);
    printf ("Shuffle Player %s", VERSION);
    
    
    attr_old(0, 32, WHITE);    
    attr_old(32, 32*4, BLUE*8+WHITE);
    attr_old(32*5, 32, WHITE);
    attr_old(32*6, 32*18, BLACK*8+WHITE+64);     
    
    gotoxy(2, 13);  
    printf(arg);
    gotoxy(0, 15);  
    printf("Additional controls: Space, P,");
    gotoxy(0, 16);  
    printf("Cursor keys,  Enter, Backspace.");
    
    attr_old(32*15, 32*2, BLACK*8+WHITE);  
}


unsigned int seed;

unsigned int rand(void)
{
  seed = ((7621 * seed + 1) % 32768);
  
  return seed;
}


void Randomize(void)
{
  seed = get_r()*256;
}

